/*!
 ***************************************************************************
 *	cdcscope.ini ̓ǂݍ.
 ***************************************************************************
 */
#include	<stdio.h>
#include	<stdlib.h>
#include	<malloc.h>
#include	<string.h>
#include	<ctype.h>
#include	"config.h"


#define	LINE_MAX_CHR			(1024)
#define	MAX_KEYS				(1024)

/*!
 ***************************************************************************
 *	yAe[uƁAo^
 ***************************************************************************
 */
typedef	struct {
	char *key;
	char *value;
} Config_pair;

static	Config_pair config_pair[MAX_KEYS];
static	int	config_idx=0;

void ConfigSetup(void);
/*!
 ***************************************************************************
 *		obt@dup.
 ***************************************************************************
 */
static	char *xstrdup(char *s)
{
	char *buf = malloc(strlen(s)+1);
	if(buf==NULL) {
		printf("Memory Exhausted!\n");
		exit(1);
	}
	strcpy(buf,s);
	return buf;
}

/*!
 ***************************************************************************
 *	config l̃yAe[uɓo^.
 ***************************************************************************
 */
static void addkey(char *key,char *value)
{
	Config_pair *db = &config_pair[config_idx];
	if( (config_idx+1) >= MAX_KEYS) {
		printf("Keys Exhausted!\n");
		exit(1);
	}

	db->key   = xstrdup(key);
	db->value = xstrdup(value);
#if	1	// debug
	printf("addkey '%s' = %s\n",db->key,db->value);
#endif

	config_idx++;
}

/*!
 ***************************************************************************
 *	' ' TAB '=' ̂ꂩȂtrue.
 ***************************************************************************
 */
static	int is_spaceeq(int c)
{
	if((c==' ')
	 ||(c=='\t')
	 ||(c=='=')) {
	 	return 1;
	}
	return 0;
}

/*!
 ***************************************************************************
 *	
 ***************************************************************************
 */
static	int is_symbol(int c)
{
	if(isalnum(c)) return 1;
	if(c == '_'  ) return 1;
	return 0;
}


/*!
 ***************************************************************************
 *	󔒕ǂݔ΂.
 ***************************************************************************
 */
static	char *sp_skip(char *p)
{
	while(is_spaceeq(*p)) p++;
	return p;
}

/*!
 ***************************************************************************
 *	㑱̋󔒕Jbg.
 ***************************************************************************
 */
static	void cut_sp(char *p)
{
	while(*p) {
		if( is_spaceeq(*p) ) {	//󔒕I.
			*p = 0; return;
		}
		p++;					//Ђǂݔ΂.
	}
}
/*!
 ***************************************************************************
 *	s
 ***************************************************************************
 */
static	int getln(char *buf,FILE *fp)
{
	int l=0;
	int c;
	while(1) {
		c=getc(fp);
		if(c==EOF)  return(EOF);/* EOF */
		if(c==0x0d) continue;
		if(c==0x0a) {
			*buf = 0;	/* EOL */
			return(0);	/* OK  */
		}
		*buf++ = c;l++;
		if(l>=255) {
			*buf = 0;
			return(1);	/* Too long line */
		}
	}
}

/*!
 ***************************************************************************
 *	cdcscope.ini ɋLqꂽŝPs̕(KEY=Value)߂ēo^B
 ***************************************************************************
 */
void parseConfig(char *lnbuf)
{
	char *key = NULL;
	char *val = NULL;
	char *split = NULL;
	char *p;
	int c;

	p = sp_skip(lnbuf);				// s̋󔒂skip.
	c = *p;
	if(c==0) return;
	if(c==';') return;
	if(is_symbol(c)) {
		key = p;
		p = strchr(p,'=');
		if(p) {
			split = p;
			val = sp_skip(p+1);		// = ̌̕Ԃ.
		}
	}
	if(val != NULL) {
		*split = 0;
		cut_sp(key);
		addkey(key,val);			// L[lo^.
	}
}

/*!
 ***************************************************************************
 *	cdcscope.ini ǂݍŁA conf \̂̃o[̒lɔf.
 ***************************************************************************
 */
int	ConfigInit(char *fname)
{
	char lnbuf[LINE_MAX_CHR];			//Psǂݍ݃[N.
	int rc;
	FILE *fp = fopen(fname,"rb");
	if(fp) {
		while(1) {
			rc = getln(lnbuf,fp);
			if(rc==EOF) break;
			parseConfig(lnbuf);
		}
		fclose(fp);
		ConfigSetup();
		return 1;
	}
	return 0;
}

/*!
 ***************************************************************************
 *	init@CɋLqꂽL[(key) Aqbg炻̒l̕Ԃ.
 ***************************************************************************
 */
char *GetConfigValue(char *key)
{
	Config_pair *db = config_pair;
	int i;
	for(i=0;i<config_idx;i++,db++) {
		if( strcmp( db->key , key ) == 0) {
			return db->value;
		}
	}
	return NULL;
}

/*!
 ***************************************************************************
 *	init@CɋLqꂽL[(key) ̒l ϐ(*var) ɑ
 ***************************************************************************
 */
void ConfigInteger(char *key,int  *var)
{
	char *str = GetConfigValue(key);
	if(str) {
		sscanf(str,"%i",var);
	}
}
/*!
 ***************************************************************************
 *	init@CɋLqꂽL[(key) ̒l ϐ(*var) ɑ
 ***************************************************************************
 */
void ConfigDouble(char *key,double *var)
{
	char *str = GetConfigValue(key);
	if(str) {
		sscanf(str,"%lg",var);
	}
}

